#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <Canvas\Canvas.mqh>
input double ResizeFactor=1.4;//Resize Factor (X)
enum mod
{
modus_simple=1,//Simple
modus_avg=2,//Average
modus_hsl=3,//HSL
modus_clamp=4,//Clamp
modus_perc=5,//Percent
modus_ld=6,//Lighter+Darker
modus_fitin=7,//FitIn
modus_light=8//Lighter
};
input mod G_Main_modus=modus_avg;//Mode :
input int G_Main_LigThreshold=382;//Lightness Threshold
input int G_Main_DifThreshold=200;//Difference Post Processing Threshold
enum post_p
{
post_none=1,//None
post_selective=2,//Selective
post_fitin=3//FitIn
};
input post_p G_Main_post_processing=post_none;//Post Processing :
enum sharpen
{
sharpen_none=1,//Dont
sharpen_edges=2//Edges
};
input sharpen G_Main_post_sharpen=sharpen_edges;//Post Sharpening :
input int G_Main_sharpen_amount=11;//Sharpen %
//GRAPHICS SETTINGS END HERE 
#resource "\\Files\\forum.bmp"; 

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
  string Resource="::Files\\forum.bmp";
  string NewResource="NR.bmp";
  int OriginalSizeX=500;
  int OriginalSizeY=375;
  double rax,ray,ratio;
  rax=(double)OriginalSizeX;
  ray=(double)OriginalSizeY;
  ratio=rax/ray;
  rax=rax*ResizeFactor;
  ray=ray*ResizeFactor;
  int NewSizeX=(int)rax;
  int NewSizeY=(int)ray;
  ResizeResource(false,Resource,OriginalSizeX,OriginalSizeY,NewSizeX,NewSizeY,NewResource,true,NewResource,false,0); 
  bool obji;
  string obj_name="NR";
  string used_resource_name="::"+NewResource;
  ObjectsDeleteAll(0,obj_name);
  obji=ObjectCreate(0,obj_name,OBJ_BITMAP_LABEL,0,0,0);
  ObjectSetInteger(0,obj_name,OBJPROP_XSIZE,NewSizeX);
  ObjectSetInteger(0,obj_name,OBJPROP_YSIZE,NewSizeY);
  ObjectSetInteger(0,obj_name,OBJPROP_XDISTANCE,0);
  ObjectSetInteger(0,obj_name,OBJPROP_YDISTANCE,0);
  ObjectSetString(0,obj_name,OBJPROP_BMPFILE,used_resource_name); 
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+

void ResizeResource(bool is_button,string resource_name,int original_width,int original_height,int target_width,int target_height,string savename,bool for_resource,string resource_export_name,bool reduce_alpha,int alpha_reduction_percentage)
 {
 
 //create original one dimensional array 
 uint original_dataz[1];
 int data_size=original_width*original_height;
 ArrayResize(original_dataz,data_size);
 //create target one dimensional array
 uint target_dataz[1];
 int target_size=target_width*target_height;
 //target size culling , cant pass 16 mega bytes (16000000)
 int bytes=target_size*4;
 double divider=1.05;
 while(bytes>=16000000)
  {
  target_width=target_width/divider;
  target_height=target_height/divider;
  target_size=target_width*target_height;
  bytes=target_size*4;
  }
 //target size culling , cant pass 16 mega bytes ends here 
 ArrayResize(target_dataz,target_size);
 
 //Arrays are ready , grab original data 
 uint red_width,red_height;
 bool read=ResourceReadImage(resource_name,original_dataz,red_width,red_height);
 //if read is failed
  if(read==false)
   {
   Alert("Restart Program Error In Graphics Resizing :"+GetLastError());
   }
 //if read is failed ends here 
 //if read is succesful
  if(read)
  {
  uint col;
  int targ_wid=target_width;
  int targ_hei=target_height;
  int wid=original_width;
  int hei=original_height;
  double w_step=targ_wid;
         w_step=w_step/wid;
  double h_step=targ_hei;
         h_step=h_step/hei;
  double w_c,h_c;
  w_c=0;
  h_c=0;
  //bigger to smaller 
    //find box size 1x1 on small is XxY on big
    double box_x=wid;
           box_x=box_x/targ_wid;
    double box_y=hei;
           box_y=box_y/targ_hei;
    double sum_sx=0;
    double sum_sy=0;
    double ent_sx=0;
    double ent_sy=0;
    ulong summation;
    int a_summation;
    int r_summation;
    int g_summation;
    int b_summation;
    int r_lighter,g_lighter,b_lighter;
    int r_darker,g_darker,b_darker;
    int rgb_lighter,rgb_darker,rgb_sum;
    int light_sums,dark_sums;
    int r_light_sums,g_light_sums,b_light_sums;
    int r_dark_sums,g_dark_sums,b_dark_sums;
    int l_summation;
    double hue,sat,lig;
    uint coloz;
    uint bit24=256*256*256;
    uint bit16=256*256;
    uint bit8=256;
    double c_r,c_g,c_b;
    bit24=bit24-bit16;
    bit16=bit16-bit8;
    int sums=0;
    int original_co=0;
    int target_co=0;
    //new data
    //uint new_dataz[3000][3000];
    for(int ny=0;ny<targ_hei;ny++) 
    {
    sum_sx=0;
    for(int nx=0;nx<targ_wid;nx++)
      {
      summation=0;
      a_summation=0;
      r_summation=0;
      g_summation=0;
      b_summation=0;
      l_summation=0;
      r_light_sums=0;
      g_light_sums=0;
      b_light_sums=0;
      light_sums=0;
      r_dark_sums=0;
      g_dark_sums=0;
      b_dark_sums=0;
      dark_sums=0;
      hue=0;
      sat=0;
      lig=0;
      sums=0;
      //loop in original  
        ent_sx=sum_sx+box_x;
        ent_sy=sum_sy+box_y;
        if(ent_sx>=wid) ent_sx=wid-1;
        if(ent_sy>=hei) ent_sy=hei-1;
        //pixel derivation starts here 
        rgb_darker=255*3;
        rgb_lighter=0;
        for(int loy=sum_sy;loy<=ent_sy;loy++)
         {
         for(int lox=sum_sx;lox<=ent_sx;lox++)
           {
           uint a,x,r,g,b;
           //AAA.BBB.CCC.DDD
           original_co=(loy*wid)+lox;
             //original value 
             coloz=original_dataz[original_co];
           //DDD
             uint tdd=coloz/256;
             uint ddd=coloz-tdd*256;
           //CCC
             uint tcc=tdd/256;
             uint ccc=tdd-tcc*256;
           //BBB
             uint tbb=tcc/256;
             uint bbb=tcc-tbb*256;
           //AAA
             uint aaa=tbb;
           
           b=ddd;
           g=ccc;
           r=bbb;
           a=aaa;
           if(a<0) a=0;
           if(a>255) a=255;
           if(r<0) r=0;
           if(r>255) r=255;
           if(g<0) g=0;
           if(g>255) g=255;
           if(b<0) b=0;
           if(b>255) b=255;
           //lighter
           if(G_Main_modus==modus_light)
           {
           rgb_sum=r+g+b;
           a_summation=a_summation+a;
           if(a>0)
            {
            if(rgb_sum<rgb_darker)
              {
              rgb_darker=rgb_sum;
              r_darker=r;
              g_darker=g;
              b_darker=b;
              }
            if(rgb_sum>rgb_lighter)
              {
              rgb_lighter=rgb_sum;
              r_lighter=r;
              g_lighter=g;
              b_lighter=b;
              }
            }        
           }
           //fit in
           if(G_Main_modus==modus_fitin)
           {
           rgb_sum=r+g+b;
           a_summation=a_summation+a;
           if(a>0)
            {
            if(rgb_sum<rgb_darker)
              {
              rgb_darker=rgb_sum;
              r_darker=r;
              g_darker=g;
              b_darker=b;
              }
            if(rgb_sum>rgb_lighter)
              {
              rgb_lighter=rgb_sum;
              r_lighter=r;
              g_lighter=g;
              b_lighter=b;
              }
            if(rgb_sum>=G_Main_LigThreshold)
              {
              light_sums++;
              r_light_sums=r_light_sums+r;
              g_light_sums=g_light_sums+g;
              b_light_sums=b_light_sums+b;
              }
            if(rgb_sum<G_Main_LigThreshold)
              {
              dark_sums++;
              r_dark_sums=r_dark_sums+r;
              g_dark_sums=g_dark_sums+g;
              b_dark_sums=b_dark_sums+b;
              }
            }
           l_summation=l_summation+rgb_sum;
           }          
           //fit in ends here 
           //mode darker and ligher
           if(G_Main_modus==modus_ld)
           {
           rgb_sum=r+g+b;
           a_summation=a_summation+a;
           if(a>0)
            {
            if(rgb_sum<rgb_darker)
              {
              rgb_darker=rgb_sum;
              r_darker=r;
              g_darker=g;
              b_darker=b;
              }
            if(rgb_sum>rgb_lighter)
              {
              rgb_lighter=rgb_sum;
              r_lighter=r;
              g_lighter=g;
              b_lighter=b;
              }
            }
           }
           //mode darker and ligher ends here
           if(G_Main_modus==modus_simple||is_button==true)
           {
           a_summation=a;
           r_summation=r;
           g_summation=g;
           b_summation=b;
           }
           if(G_Main_modus==modus_avg&&is_button==false)
           {
           a_summation=a_summation+a;
           r_summation=r_summation+r;
           g_summation=g_summation+g;
           b_summation=b_summation+b;           
           }
           if(G_Main_modus==modus_perc)
           {
           if(sums==0)
             {
             a_summation=a;
             r_summation=r;
             g_summation=g;
             b_summation=b;             
             }
           if(sums>0)
             {
             a_summation=(a_summation+a)/2;
             double old_red_sq,old_green_sq,old_blue_sq;
             double red_sq,green_sq,blue_sq;
             double sq_a=0.75;
             double sq_b=0.25;
             red_sq=r*r;
             green_sq=g*g;
             blue_sq=b*b;
             old_red_sq=r_summation*r_summation;
             old_green_sq=g_summation*g_summation;
             old_blue_sq=b_summation*b_summation;
             double red_s,green_s,blue_s;
             red_s=sq_a*old_red_sq+sq_b*red_sq;
             red_s=MathSqrt(red_s);
             green_s=sq_a*old_green_sq+sq_b*green_sq;
             green_s=MathSqrt(green_s);
             blue_s=sq_a*old_blue_sq+sq_b*blue_sq;
             blue_s=MathSqrt(blue_s);
             r_summation=red_s;
             g_summation=green_s;
             b_summation=blue_s;
             }
           }
           if(G_Main_modus==modus_clamp)
           {
           if(sums==0)
             {
             a_summation=a;
             r_summation=r;
             g_summation=g;
             b_summation=b;
             }
           if(sums>0)
             {
             a_summation=(a_summation+a)/2;
             double ligi_old=(r_summation+g_summation+b_summation)/3;
             ligi_old=ligi_old/255;
             double ligi_new=(r+g+b)/3;
                    ligi_new=ligi_new/255;
             double ligi_sum=ligi_new+ligi_old;
             if(ligi_sum>0)
               {
               r_summation=(r_summation*ligi_old+r*ligi_new)/ligi_sum;
               g_summation=(g_summation*ligi_old+g*ligi_new)/ligi_sum;
               b_summation=(b_summation*ligi_old+b*ligi_new)/ligi_sum;
               }
             if(ligi_sum==0)
               {
               r_summation=0;
               g_summation=0;
               b_summation=0;
               }
             }
           }
           if(G_Main_modus==modus_hsl)
           {
           //convert to hsl 
           a_summation=a_summation+a;
          
           c_r=r;
           c_r=c_r/255;
           c_g=g;
           c_g=c_g/255;
           c_b=b;
           c_b=c_b/255;
           double c_min=MathMin(c_r,c_g);
                  c_min=MathMin(c_min,c_b);
           double c_max=MathMax(c_r,c_g);
                  c_max=MathMax(c_max,c_b);
           //luminance
           double lumin=(c_min+c_max)/2;
           lumin=lumin*100;
           double satur,thehue;
           //saturation
             //if min=max no saturation hue =0;
             if(c_min==c_max)
              {
              satur=0;
              hue=0;
              }
             if(c_min!=c_max)
              {
              satur=(c_max-c_min)/(1-MathAbs(2*(lumin/100)-1));
              satur=satur*100;
              //hue 
              if(c_r>c_b&&c_r>c_g) thehue=(c_g-c_b)/(c_max-c_min);
              if(c_g>c_b&&c_g>c_r) thehue=2+(c_b-c_r)/(c_max-c_min);
              if(c_b>c_g&&c_b>c_r) thehue=4+(c_r-c_g)/(c_max-c_min);
              thehue=thehue*60;
              if(thehue<0) thehue=thehue+360;
              }
           hue=hue+thehue;
           sat=sat+satur;
           lig=lig+lumin;                   
           }
           sums++;
           }
         }
         //pixel derivation ends here  
           if(G_Main_modus==modus_light) 
            {
            a_summation=a_summation/sums;
            r_summation=r_lighter;
            g_summation=g_lighter;
            b_summation=b_lighter;
            }
           if(G_Main_modus==modus_fitin)
            {
            a_summation=a_summation/sums;
            l_summation=l_summation/sums;
            if(l_summation>=G_Main_LigThreshold)
             {
             r_summation=r_light_sums/light_sums;
             g_summation=g_light_sums/light_sums;
             b_summation=b_light_sums/light_sums;
             }            
            if(l_summation<G_Main_LigThreshold)
             {
             r_summation=r_dark_sums/dark_sums;
             g_summation=g_dark_sums/dark_sums;
             b_summation=b_dark_sums/dark_sums;
             }
            }
           if(G_Main_modus==modus_ld)
            {
            a_summation=a_summation/sums;
            r_summation=(r_lighter+r_darker)/2;
            g_summation=(g_lighter+g_darker)/2;
            b_summation=(b_lighter+b_darker)/2;
            }
           if(G_Main_modus==modus_hsl)
            {
            double temp1,temp2,tempr,tempg,tempb,temphue,outr,outg,outb;
            a_summation=a_summation/sums;
            hue=hue/sums;
            sat=sat/sums;
            lig=lig/sums;
            //hsl to rgb
              //if saturation is 0
              if(sat==0)
              {
              double coli=(lig/100)*255;
              r_summation=coli;
              g_summation=coli;
              b_summation=coli;
              }
              //if saturation > 0
              if(sat>0)
              {
              double hsl_hue=hue;
              double hsl_hue2;
              double hsl_sat=sat;
                     hsl_sat=hsl_sat/100;
              double hsl_lig=lig;
                     hsl_lig=hsl_lig/100;
              double hsl_c;
              double hsl_x;
              double hsl_m;
              double hsl_r,hsl_g,hsl_b;
              hsl_c=(1-MathAbs(2*hsl_lig-1))*hsl_sat;
              hsl_hue2=hsl_hue/60;
              hsl_x=hsl_c*(1-MathAbs(MathMod(hsl_hue2,2)-1));
              if(hsl_hue2>=0&&hsl_hue2<1)
               {
               hsl_r=hsl_c;
               hsl_g=hsl_x;
               hsl_b=0;
               }
              if(hsl_hue2>=1&&hsl_hue2<2)
               {
               hsl_r=hsl_x;
               hsl_g=hsl_c;
               hsl_b=0;
               }
              if(hsl_hue2>=2&&hsl_hue2<3)
               {
               hsl_r=0;
               hsl_g=hsl_c;
               hsl_b=hsl_x;
               }
              if(hsl_hue2>=3&&hsl_hue2<4)
               {
               hsl_r=0;
               hsl_g=hsl_x;
               hsl_b=hsl_c;
               }
              if(hsl_hue2>=4&&hsl_hue2<5)
               {
               hsl_r=hsl_x;
               hsl_g=0;
               hsl_b=hsl_c;
               }
              if(hsl_hue2>=5&&hsl_hue2<6)
               {
               hsl_r=hsl_c;
               hsl_g=0;
               hsl_b=hsl_x;
               }
               hsl_m=hsl_lig-hsl_c/2;
               hsl_r=hsl_r+hsl_m;
               hsl_g=hsl_g+hsl_m;
               hsl_b=hsl_b+hsl_m;
               r_summation=hsl_r*255;
               g_summation=hsl_g*255;
               b_summation=hsl_b*255;
              }
             //if sat > 0 ends here 
            }
           //if hsl mode ends hre
           if(G_Main_modus==modus_avg&&is_button==false)
           {      
           a_summation=a_summation/sums;
           r_summation=r_summation/sums;
           g_summation=g_summation/sums;
           b_summation=b_summation/sums;
           }
        if(reduce_alpha==true&&is_button==false)
        {
        int make_pass=a_summation;
        double ori_alpha=make_pass;
        double ori_alpha_unit=ori_alpha/100;
        a_summation=0;
        if(ori_alpha_unit>0)
         {
         ori_alpha=ori_alpha-ori_alpha_unit*alpha_reduction_percentage;
         make_pass=ori_alpha;
         a_summation=make_pass;
         if(a_summation>255) a_summation=255;
         if(a_summation<0) a_summation=0;
         }
        }
        coloz=ARGBToUint(a_summation,r_summation,g_summation,b_summation);
        target_co=(ny*targ_wid)+nx;
        //Bitmap1.PixelSet(nx,ny,coloz);
        target_dataz[target_co]=coloz;
        sum_sx=sum_sx+box_x;
      //loop in origina lends here 
      }
    sum_sy=sum_sy+box_y;
    }
  //bigger to smaller ends here  
  
  //sharpness preparation
    int sha_len=ArraySize(target_dataz);
    int sharp_mask[1];
    if(G_Main_post_sharpen!=sharpen_none)
    {
    ArrayResize(sharp_mask,sha_len,0);
    }
    //sharpen edges , detect edges 
    if(G_Main_post_sharpen==sharpen_edges&&is_button==false)
    {
     int orig_rgb_sum;
     int dummy_co=0;
     int loc_rgb_sum;
    //0 nothing , 1 lighten 2 darken
      for(int ny=0;ny<targ_hei;ny++) 
      {
      for(int nx=0;nx<targ_wid;nx++)
      {
       //get original color 
       uint orig_a,orig_x,orig_r,orig_g,orig_b;
       uint loc_a,loc_x,loc_r,loc_g,loc_b;
       target_co=(ny*targ_wid)+nx;
       coloz=target_dataz[target_co];
       sharp_mask[target_co]=0;
             //DDD
             uint tdd=coloz/256;
             uint ddd=coloz-tdd*256;
             //CCC
             uint tcc=tdd/256;
             uint ccc=tdd-tcc*256;
             //BBB
             uint tbb=tcc/256;
             uint bbb=tcc-tbb*256;
             //AAA
             uint aaa=tbb;
             orig_b=ddd;
             orig_g=ccc;
             orig_r=bbb;
             orig_a=aaa;
             if(orig_a<0) orig_a=0;
             if(orig_a>255) orig_a=255;
             if(orig_r<0) orig_r=0;
             if(orig_r>255) orig_r=255;
             if(orig_g<0) orig_g=0;
             if(orig_g>255) orig_g=255;
             if(orig_b<0) orig_b=0;
             if(orig_b>255) orig_b=255;  
             orig_rgb_sum=orig_r+orig_g+orig_b;
             //if original alpha is not zero
             if(orig_a>0)
             {
             //Loop within surrounding pixels
               int s_sx,s_ex,s_sy,s_ey;
               s_sx=nx-1;
               s_sy=ny-1;
               s_ex=nx+1;
               s_ey=ny+1;
               if(s_sx<0) s_sx=0;
               if(s_sy<0) s_sy=0;
               if(s_ex>targ_wid-1) s_ex=targ_wid-1;
               if(s_ey>targ_hei-1) s_ey=targ_hei-1;
               bool broken=false;
               for(int lox=s_sx;lox<=s_ex;lox++)
                  {
                  for(int loy=s_sy;loy<=s_ey;loy++)
                     {
                     //IF THIS IS NOT THE CENTRAL PIXEL PROCESS
                       if(lox!=nx||loy!=ny)
                       {
                       dummy_co=(loy*targ_wid)+lox;
                       coloz=target_dataz[dummy_co];
                       //DDD
                       tdd=coloz/256;
                       ddd=coloz-tdd*256;
                       //CCC
                       tcc=tdd/256;
                       ccc=tdd-tcc*256;
                       //BBB
                       tbb=tcc/256;
                       bbb=tcc-tbb*256;
                       //AAA
                       aaa=tbb;
                       loc_b=ddd;
                       loc_g=ccc;
                       loc_r=bbb;
                       loc_a=aaa;
                       if(loc_a<0) loc_a=0;
                       if(loc_a>255) loc_a=255;
                       if(loc_r<0) loc_r=0;
                       if(loc_r>255) loc_r=255;
                       if(loc_g<0) loc_g=0;
                       if(loc_g>255) loc_g=255;
                       if(loc_b<0) loc_b=0;
                       if(loc_b>255) loc_b=255;                         
                       //if its not transparent
                         if(loc_a>0)
                         {
                         loc_rgb_sum=loc_r+loc_g+loc_b;
                         int dif=loc_rgb_sum-orig_rgb_sum;
                             dif=MathAbs(dif);
                             if(dif>=G_Main_DifThreshold)
                             {
                             if(orig_rgb_sum>=G_Main_LigThreshold)
                              {
                              sharp_mask[target_co]=1;
                              }
                             if(orig_rgb_sum<G_Main_LigThreshold)
                              {
                              sharp_mask[target_co]=2;
                              }
                             broken=true;
                             break;
                             }
                         }
                       //if its not transparent ends here 
                       }
                     //IF THIS IS NOT THE CENTRAL PIXEL PROCESS ENDS HERE 
                     }
                   if(broken) break;
                  }
             //Loop within surrounding pixels ends here  
             }
             //if original alpha is not zero ends here    
      }
      }
      //loop into target data ends here     
    }
    //sharpen edges , detect edges ends here
  //sharpness preparation ends here 
  //post processing 
      //get array length 
      int arr_len=ArraySize(target_dataz);
      uint dummy[1];  
    //if post processing is not off prepare arrays
      if(G_Main_post_processing!=post_none)
      {
      ArrayResize(dummy,arr_len,0);    
      }
    //if post processing is not off prepare arrays ends here 
    //selective post processing 
     if(G_Main_post_processing==post_selective)
     {
     int copies=ArrayCopy(dummy,target_dataz,0,0,arr_len);
      //loop into target data 
      int dummy_co=0;
      int orig_rgb_sum;
      int loc_rgb_sum;
      int res_r,res_g,res_b,res_a;
      for(int ny=0;ny<targ_hei;ny++) 
      {
      for(int nx=0;nx<targ_wid;nx++)
      {
       //get original color 
       uint orig_a,orig_x,orig_r,orig_g,orig_b;
       uint loc_a,loc_x,loc_r,loc_g,loc_b;
       target_co=(ny*targ_wid)+nx;
       coloz=target_dataz[target_co];
             //DDD
             uint tdd=coloz/256;
             uint ddd=coloz-tdd*256;
             //CCC
             uint tcc=tdd/256;
             uint ccc=tdd-tcc*256;
             //BBB
             uint tbb=tcc/256;
             uint bbb=tcc-tbb*256;
             //AAA
             uint aaa=tbb;
             orig_b=ddd;
             orig_g=ccc;
             orig_r=bbb;
             orig_a=aaa;
             if(orig_a<0) orig_a=0;
             if(orig_a>255) orig_a=255;
             if(orig_r<0) orig_r=0;
             if(orig_r>255) orig_r=255;
             if(orig_g<0) orig_g=0;
             if(orig_g>255) orig_g=255;
             if(orig_b<0) orig_b=0;
             if(orig_b>255) orig_b=255;  
             orig_rgb_sum=orig_r+orig_g+orig_b;
             //if original alpha is not zero
             if(orig_a>0)
             {
             //Loop within surrounding pixels
               int s_sx,s_ex,s_sy,s_ey;
               s_sx=nx-1;
               s_sy=ny-1;
               s_ex=nx+1;
               s_ey=ny+1;
               if(s_sx<0) s_sx=0;
               if(s_sy<0) s_sy=0;
               if(s_ex>targ_wid-1) s_ex=targ_wid-1;
               if(s_ey>targ_hei-1) s_ey=targ_hei-1;
               for(int lox=s_sx;lox<=s_ex;lox++)
                  {
                  for(int loy=s_sy;loy<=s_ey;loy++)
                     {
                     //IF THIS IS NOT THE CENTRAL PIXEL PROCESS
                       if(lox!=nx||loy!=ny)
                       {
                       dummy_co=(loy*targ_wid)+lox;
                       coloz=target_dataz[dummy_co];
                       //DDD
                       tdd=coloz/256;
                       ddd=coloz-tdd*256;
                       //CCC
                       tcc=tdd/256;
                       ccc=tdd-tcc*256;
                       //BBB
                       tbb=tcc/256;
                       bbb=tcc-tbb*256;
                       //AAA
                       aaa=tbb;
                       loc_b=ddd;
                       loc_g=ccc;
                       loc_r=bbb;
                       loc_a=aaa;
                       if(loc_a<0) loc_a=0;
                       if(loc_a>255) loc_a=255;
                       if(loc_r<0) loc_r=0;
                       if(loc_r>255) loc_r=255;
                       if(loc_g<0) loc_g=0;
                       if(loc_g>255) loc_g=255;
                       if(loc_b<0) loc_b=0;
                       if(loc_b>255) loc_b=255;                         
                       //if its not transparent
                         if(loc_a>0)
                         {
                         loc_rgb_sum=loc_r+loc_g+loc_b;
                         int dif=loc_rgb_sum-orig_rgb_sum;
                             dif=MathAbs(dif);
                             if(dif>=G_Main_DifThreshold)
                             {
                             res_a=(orig_a+loc_a)/2;
                             res_r=(orig_r+loc_r)/2;
                             res_g=(orig_g+loc_g)/2;
                             res_b=(orig_b+loc_b)/2;
                             uint neo=ARGBToUint(res_a,res_r,res_g,res_b);
                             dummy[dummy_co]=neo;
                             }
                         }
                       //if its not transparent ends here 
                       }
                     //IF THIS IS NOT THE CENTRAL PIXEL PROCESS ENDS HERE 
                     }
                  }
             //Loop within surrounding pixels ends here  
             }
             //if original alpha is not zero ends here    
      }
      }
      //loop into target data ends here 
     }
    //selective post processing ends here 
    //fit in post processing 
     if(G_Main_post_processing==post_fitin)
     {
     int copies=ArrayCopy(dummy,target_dataz,0,0,arr_len);
      //loop into target data 
      int dummy_co=0;
      int orig_rgb_sum;
      int loc_rgb_sum;
      int res_r,res_g,res_b,res_a;
      int mix_sums=0;
      int mix_red=0;
      int mix_green=0;
      int mix_blue=0;
      int mix_alpha=0;
      int mix_rgb_sum=0;
      for(int ny=0;ny<targ_hei;ny++) 
      {
      for(int nx=0;nx<targ_wid;nx++)
      {
       //get original color 
       uint orig_a,orig_x,orig_r,orig_g,orig_b;
       uint loc_a,loc_x,loc_r,loc_g,loc_b;
       target_co=(ny*targ_wid)+nx;
       coloz=target_dataz[target_co];
             //DDD
             uint tdd=coloz/256;
             uint ddd=coloz-tdd*256;
             //CCC
             uint tcc=tdd/256;
             uint ccc=tdd-tcc*256;
             //BBB
             uint tbb=tcc/256;
             uint bbb=tcc-tbb*256;
             //AAA
             uint aaa=tbb;
             orig_b=ddd;
             orig_g=ccc;
             orig_r=bbb;
             orig_a=aaa;
             if(orig_a<0) orig_a=0;
             if(orig_a>255) orig_a=255;
             if(orig_r<0) orig_r=0;
             if(orig_r>255) orig_r=255;
             if(orig_g<0) orig_g=0;
             if(orig_g>255) orig_g=255;
             if(orig_b<0) orig_b=0;
             if(orig_b>255) orig_b=255;  
             orig_rgb_sum=orig_r+orig_g+orig_b;
             //if original alpha is not zero
             if(orig_a>0)
             {
             //Loop within surrounding pixels
               int s_sx,s_ex,s_sy,s_ey;
               s_sx=nx-1;
               s_sy=ny-1;
               s_ex=nx+1;
               s_ey=ny+1;
               mix_sums=0;
               mix_alpha=0;
               mix_red=0;
               mix_green=0;
               mix_blue=0;
               mix_rgb_sum=0;
               if(s_sx<0) s_sx=0;
               if(s_sy<0) s_sy=0;
               if(s_ex>targ_wid-1) s_ex=targ_wid-1;
               if(s_ey>targ_hei-1) s_ey=targ_hei-1;
               for(int lox=s_sx;lox<=s_ex;lox++)
                  {
                  for(int loy=s_sy;loy<=s_ey;loy++)
                     {
                     //IF THIS IS NOT THE CENTRAL PIXEL PROCESS
                       if(lox!=nx||loy!=ny)
                       {
                       dummy_co=(loy*targ_wid)+lox;
                       coloz=target_dataz[dummy_co];
                       //DDD
                       tdd=coloz/256;
                       ddd=coloz-tdd*256;
                       //CCC
                       tcc=tdd/256;
                       ccc=tdd-tcc*256;
                       //BBB
                       tbb=tcc/256;
                       bbb=tcc-tbb*256;
                       //AAA
                       aaa=tbb;
                       loc_b=ddd;
                       loc_g=ccc;
                       loc_r=bbb;
                       loc_a=aaa;
                       if(loc_a<0) loc_a=0;
                       if(loc_a>255) loc_a=255;
                       if(loc_r<0) loc_r=0;
                       if(loc_r>255) loc_r=255;
                       if(loc_g<0) loc_g=0;
                       if(loc_g>255) loc_g=255;
                       if(loc_b<0) loc_b=0;
                       if(loc_b>255) loc_b=255;                         
                       //if its not transparent
                         if(loc_a>0)
                         {
                         mix_sums++;
                         mix_red=mix_red+loc_r;
                         mix_alpha=mix_alpha+loc_a;
                         mix_green=mix_green+loc_g;
                         mix_blue=mix_blue+loc_b;
                         mix_rgb_sum=mix_rgb_sum+loc_r+loc_g+loc_b;
                         }
                       //if its not transparent ends here 
                       }
                     //IF THIS IS NOT THE CENTRAL PIXEL PROCESS ENDS HERE 
                     }
                  }
             //Loop within surrounding pixels ends here  
             //compare colors
               if(mix_sums>0)
               {
               mix_red=mix_red/mix_sums;
               mix_alpha=mix_alpha/mix_sums;
               mix_green=mix_green/mix_sums;
               mix_blue=mix_blue/mix_sums;
               mix_rgb_sum=mix_red+mix_green+mix_blue;
               int dif=MathAbs(mix_rgb_sum-orig_rgb_sum);
               if(dif>G_Main_DifThreshold)
                 {
                 res_a=(mix_alpha+orig_a)/2;
                 res_r=(mix_red+orig_r)/2;
                 res_g=(mix_green+orig_g)/2;
                 res_b=(mix_blue+orig_b)/2;
                 uint neo=ARGBToUint(res_a,res_r,res_g,res_b);
                 dummy_co=(ny*targ_wid)+nx;
                 dummy[dummy_co]=neo;                 
                 }
               }
             //compare colors ends here 
             }
             //if original alpha is not zero ends here    
      }
      }
      //loop into target data ends here 
     }
    //fit in post processing ends here 
    //if post processing is not off pass back data 
    if(G_Main_post_processing!=post_none)
     {
     int copi=ArrayCopy(target_dataz,dummy,0,0,WHOLE_ARRAY);
     }
    //if post processing is not off pass back data ends here 
    
    //if sharpness is applied 
    if(G_Main_post_sharpen==sharpen_edges&&is_button==false)
     {
    //0 nothing , 1 lighten 2 darken
      for(int ny=0;ny<targ_hei;ny++) 
      {
      for(int nx=0;nx<targ_wid;nx++)
      {
       //get original color 
       uint orig_a,orig_x,orig_r,orig_g,orig_b;
       uint loc_a,loc_x,loc_r,loc_g,loc_b;
       target_co=(ny*targ_wid)+nx;
       coloz=target_dataz[target_co];
             //DDD
             uint tdd=coloz/256;
             uint ddd=coloz-tdd*256;
             //CCC
             uint tcc=tdd/256;
             uint ccc=tdd-tcc*256;
             //BBB
             uint tbb=tcc/256;
             uint bbb=tcc-tbb*256;
             //AAA
             uint aaa=tbb;
             orig_b=ddd;
             orig_g=ccc;
             orig_r=bbb;
             orig_a=aaa;
             if(orig_a<0) orig_a=0;
             if(orig_a>255) orig_a=255;
             if(orig_r<0) orig_r=0;
             if(orig_r>255) orig_r=255;
             if(orig_g<0) orig_g=0;
             if(orig_g>255) orig_g=255;
             if(orig_b<0) orig_b=0;
             if(orig_b>255) orig_b=255;  
             //if original alpha is not zero
             if(orig_a>0)
             {
             int res_a,res_r,res_g,res_b;
             //if mask is lighten
               if(sharp_mask[target_co]==1)
               {
               res_r=orig_r+(orig_r*G_Main_sharpen_amount)/100;
               res_g=orig_g+(orig_g*G_Main_sharpen_amount)/100;
               res_b=orig_b+(orig_b*G_Main_sharpen_amount)/100;
                       if(res_a<0) res_a=0;
                       if(res_a>255) res_a=255;
                       if(res_r<0) res_r=0;
                       if(res_r>255) res_r=255;
                       if(res_g<0) res_g=0;
                       if(res_g>255) res_g=255;
                       if(res_b<0) res_b=0;
                       if(res_b>255) res_b=255; 
               uint neo=ARGBToUint(orig_a,res_r,res_g,res_b);
               target_dataz[target_co]=neo;                
               }
             //if mask is lighten ends here
             //if mask is darken
               if(sharp_mask[target_co]==2)
               {
               res_r=orig_r-(orig_r*G_Main_sharpen_amount)/100;
               res_g=orig_g-(orig_g*G_Main_sharpen_amount)/100;
               res_b=orig_b-(orig_b*G_Main_sharpen_amount)/100;
                       if(res_a<0) res_a=0;
                       if(res_a>255) res_a=255;
                       if(res_r<0) res_r=0;
                       if(res_r>255) res_r=255;
                       if(res_g<0) res_g=0;
                       if(res_g>255) res_g=255;
                       if(res_b<0) res_b=0;
                       if(res_b>255) res_b=255; 
               uint neo=ARGBToUint(orig_a,res_r,res_g,res_b);
               target_dataz[target_co]=neo;                
               }
             //if mask is darken ends here             
             }
             //if original alpha is not zero ends here    
      }
      }
      //loop into target data ends here         
     }
    //if sharpness is applied ends here 
  //post processing ends here 
  //create resource
  //for file 
  if(for_resource==false)
  {
  uint wri_width,wri_height;
  wri_width=targ_wid;
  wri_height=targ_hei;
  bool cre=ResourceCreate("Linear",target_dataz,wri_width,wri_height,0,0,wri_width,COLOR_FORMAT_ARGB_RAW);
  if(cre==false) Print("Resource Create Error : "+GetLastError());
       cre=ResourceSave("::Linear",savename);
  if(cre==false) Print("Resource Save Error : "+GetLastError());
       cre=ResourceFree("::Linear");
  }
  //for file ends here 
  //for resource 
  if(for_resource==true)
  {
  uint wri_width,wri_height;  
  wri_width=targ_wid;
  wri_height=targ_hei;
  bool cre=ResourceCreate(resource_export_name,target_dataz,wri_width,wri_height,0,0,wri_width,COLOR_FORMAT_ARGB_RAW);
  if(cre==false) Print("Resource Create Error : "+GetLastError());
  }
  //for resource ends here 
  }
 //if read is succesful ends here 
 }

int UintToAlpha(uint coloz)
{
           //DDD
             uint tdd=coloz/256;
             uint ddd=coloz-tdd*256;
           //CCC
             uint tcc=tdd/256;
             uint ccc=tdd-tcc*256;
           //BBB
             uint tbb=tcc/256;
             uint bbb=tcc-tbb*256;
           //AAA
             uint aaa=tbb;
 return((int)aaa);
}
uint ARGBToUint(int alpha,int red,int green,int blue)
 {
 uint reto;
    uint bit24=256*256*256;
    uint bit16=256*256;
    uint bit8=256; 
    bit24=bit24;
    bit16=bit16;    
 reto = alpha*bit24 + red*bit16 + green*bit8 + blue;
 return(reto);
 }
 